## libjna-java 3.0.4

=== native/Makefile ===
#
# Makefile for JNA native bits
# Copyright (c) 2007 Timothy Wall All Rights Reserved
#
# You may need to run 'ant javah' at the root before performing a build from 
# this directory.
#
# To build with debug information, use 'make DEBUG=true'
#
# Supported platforms (built and tested):
#
#   Windows 2000/XP/2003/Vista (x86)
#   Darwin/OS X (i386/x86_64/ppc)
#   Linux (i386/amd64) 
#   Solaris (i386/amd64/sparc/sparcv9)
#   FreeBSD (i386/amd64)
#

# Systems which support POSIX signals may be able to support VM crash
# protection simply by defining HAVE_PROTECTION.  This has been enabled
# only for those platforms on which it has been tested successfully.

OS=$(shell uname | sed -e 's/\(CYGWIN\|MINGW32\).*/win32/g' \
                        -e 's/SunOS.*/solaris/g' \
                        -e 's/FreeBSD.*/freebsd/g' \
                        -e 's/Darwin.*/darwin/g' \
                        -e 's/Linux.*/linux/g')

VERSION=3.0.4 # auto-generated by ant
CHECKSUM=892beacd437514d23ed9b1cefeb2ead6 # auto-generated by ant

JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
              -I"$(JAVA_HOME)/include/$(OS)"

LIBDIR=$(JAVA_HOME)/jre/lib/$(ARCH)
BUILD=../build/native
JAVAH=$(BUILD)
INSTALLDIR=../build/$(OS)
JNIDISPATCH_OBJS=$(BUILD)/dispatch.o $(BUILD)/callback.o $(EXTRAOBJS)
RSRC=$(BUILD)/rsrc.o
FFI_SRC=$(shell pwd)/libffi
FFI_BUILD=$(BUILD)/libffi
FFI_LIB=$(FFI_BUILD)/.libs/libffi_convenience.a
FFI_CONFIG=--disable-static --with-pic=yes
LIBRARY=$(BUILD)/$(LIBPFX)jnidispatch$(JNISFX)
TESTLIB=$(BUILD)/$(LIBPFX)testlib$(LIBSFX)

# Reasonable defaults based on GCC
LIBPFX=lib
LIBSFX=.so
JNISFX=$(LIBSFX)
CC=gcc
LD=gcc
# Default to Sun recommendations for JNI compilation
#COPT=-O2 -fomit-frame-pointer
COPT=-fno-omit-frame-pointer -fno-strict-aliasing 
CASM=-S
ifeq ($(DEBUG),true)
CDEBUG=-g
endif
COUT=-o $@
CINCLUDES=$(JAVA_INCLUDES) -I"$(JAVAH)" -I$(FFI_BUILD)/include
CDEFINES=-D_REENTRANT
PCFLAGS=-W -Wall -Wno-unused -Wno-parentheses
CFLAGS=$(PCFLAGS) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
       -DVERSION='"$(VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
# -static-libgcc avoids gcc library incompatibilities across linux systems
LDFLAGS=-o $@ -shared -static-libgcc
# Avoid bug in X11-based 1.5/1.6 VMs; dynamically load instead of linking
# See http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6539705
#LIBS=-L"$(LIBDIR)" -ljawt 
STRIP=strip -x
# end defaults

ifeq ($(OS),win32)
# Uncomment this line to use MSVC (doesn't yet work with libffi)
#CC=cl
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
CDEFINES=-DHAVE_PROTECTION

ifeq ($(CC),cl)
LD=link
COPT=-O1 -Op
ifeq ($(DEBUG),true)
COPT=-Od
DBG=d
CDEBUG=-D_DEBUG -GZ -Zi
endif
COUT=-Fo$@
PCFLAGS=-nologo -MD$(DBG) -W3 -WX -GX -YX -Fd$(@D)/$* -Fp$(@D)/$*
CASM=-FAs

LDFLAGS=/pdb:$(subst .dll,,$@).pdb /implib:$(subst .dll,,$@).lib /debug /machine:i386 /pdbtype:sept /dll /nologo /opt:REF /incremental:no /out:$@ 
LIBDIR=/libpath:"$(JAVA_HOME)/lib" 
#LIBS=$(LIBDIR) jawt.lib
STRIP=@echo
else
CC += -mno-cygwin
LD += -mno-cygwin -Wl,--add-stdcall-alias
LIBDIR="$(JAVA_HOME)/lib"
#LIBS=$(LIBDIR)/jawt.lib
endif

LIBPFX=
LIBSFX=.dll
EXTRAOBJS=$(RSRC)
endif

ifeq ($(OS),linux)
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
PCFLAGS+=-fPIC
CDEFINES+=-DHAVE_PROTECTION
LDFLAGS+=-Wl,-soname,$@ 
endif

ifeq ($(OS),freebsd)
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
PCFLAGS+=-fPIC
CINCLUDES+=-I/usr/X11R6/include
LDFLAGS=-o $@ -shared 
CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT
endif

ifeq ($(OS),solaris)
ifeq ($(ARCH),)
ARCH=$(shell uname -p)
endif
PCFLAGS+=-fPIC
CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT
ifeq ($(ARCH), sparcv9)
  # alter CC instead of PCFLAGS, since we need to pass it down to libffi 
  # configure and some of the other settings in PCFLAGS might make the build 
  # choke
  CC += -m64  
  LD += -m64 
endif
endif

# Enable 64-bit builds if the arch demands it
ifeq ($(ARCH),amd64)
  CC += -m64
  LD += -m64
endif

ifeq ($(OS),darwin)
ARCH=$(shell arch)
ifeq ($(ARCH),ppc)
ALT_ARCHS=i386
else
ALT_ARCHS=ppc
endif
LIBSFX=.dylib
JNISFX=.jnilib
ifneq ($(SDKROOT),)
SYSLIBROOT=-Wl,-syslibroot,$(SDKROOT)
ISYSROOT=-isysroot $(SDKROOT)
ARCHFLAGS=-arch ppc -arch i386
ifneq ($(findstring 10.5,$(SDKROOT)),)
ALT_ARCHS+=x86_64 #ppc64
ARCHFLAGS+=-arch x86_64 #-arch ppc64
endif
endif
PCFLAGS+=$(ISYSROOT) -x objective-c
CDEFINES+=-DTARGET_RT_MAC_CFM=0 -DFFI_MMAP_EXEC_WRIT
LDFLAGS=$(ARCHFLAGS) -dynamiclib -o $@ -framework JavaVM \
  -compatibility_version $(shell echo ${VERSION}|sed 's/^\([0-9][0-9]*\).*/\1/g') \
  -current_version $(VERSION) \
  -mmacosx-version-min=10.3 \
  -install_name ${@F} \
  $(SYSLIBROOT)
# JAWT linkage handled by -framework JavaVM
LIBS=
endif

# Unfortunately, we have to use different libffi include files depending on 
# the target, so we can't do a simple universal build on darwin.  Do 
# separate builds, then merge the results.
$(BUILD)/%.o : %.c dispatch.h $(FFI_LIB)
	@mkdir -p $(BUILD)
ifneq ($(SDKROOT),)
	$(CC) -arch $(ARCH) $(CFLAGS) -c $< -o $@.$(ARCH)
	for arch in $(ALT_ARCHS); do \
	  $(CC) -arch $$arch -I$(BUILD)/libffi.$$arch/include $(CFLAGS) -c $< -o $@.$$arch; \
	done
	lipo -create -output $@ $@.*
else
	$(CC) $(CFLAGS) -c $< $(COUT)
endif

all: $(LIBRARY) $(TESTLIB)

install:
	mkdir $(INSTALLDIR)
	cp $(LIBRARY) $(INSTALLDIR)

$(RSRC): $(BUILD)/jnidispatch.rc
	windres -i $< -o $@

$(LIBRARY): $(JNIDISPATCH_OBJS) $(FFI_LIB) 
	$(LD) $(LDFLAGS) $(JNIDISPATCH_OBJS) $(FFI_LIB) $(LIBS)

$(TESTLIB): $(BUILD)/testlib.o 
	$(LD) $(LDFLAGS) $< $(TESTDEF)

$(FFI_LIB):
	@mkdir -p $(FFI_BUILD)
	@if [ ! -f $(FFI_BUILD)/Makefile ]; then \
	  echo "Configuring libffi ($(ARCH))"; \
	  (cd $(FFI_BUILD) \
	    && CC="$(CC)" CFLAGS="$(CDEBUG)" CPPFLAGS="$(CDEFINES)" $(FFI_SRC)/configure $(FFI_CONFIG)); \
	fi
	$(MAKE) -C $(FFI_BUILD)
ifneq ($(SDKROOT),)
	@for arch in $(ALT_ARCHS); do \
	  mkdir -p $(BUILD)/libffi.$$arch; \
	  if [ ! -f $(BUILD)/libffi.$$arch/Makefile ]; then \
	    echo "Configuring libffi ($$arch)"; \
	    (cd $(BUILD)/libffi.$$arch \
	     && CC="$(CC)" CFLAGS="-arch $$arch $(ISYSROOT) $(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)" \
                LDFLAGS="-arch $$arch" \
               $(FFI_SRC)/configure $(FFI_CONFIG) --host=$$arch-apple-darwin --disable-dependency-tracking); \
	  fi; \
	  $(MAKE) -C $(BUILD)/libffi.$$arch; \
	done
	/usr/bin/libtool -static -o $@.tmp $(FFI_BUILD)/.libs/${@F} $(BUILD)/libffi.*/.libs/${@F}
	mv $@.tmp $@
endif

clean:
	$(RM) -rf $(BUILD) 

version:
	@echo version=$(VERSION)

#EOF

## libjna-java 3.1.0

=== native/Makefile ===
--- 
+++ 
@@ -23,34 +23,40 @@
 OS=$(shell uname | sed -e 's/\(CYGWIN\|MINGW32\).*/win32/g' \
                         -e 's/SunOS.*/solaris/g' \
                         -e 's/FreeBSD.*/freebsd/g' \
+                        -e 's/OpenBSD.*/openbsd/g' \
                         -e 's/Darwin.*/darwin/g' \
                         -e 's/Linux.*/linux/g')
 
-VERSION=3.0.4 # auto-generated by ant
-CHECKSUM=892beacd437514d23ed9b1cefeb2ead6 # auto-generated by ant
+VERSION=3.1.0 # auto-generated by ant
+CHECKSUM=816e53324203bcffe46f43e482e5c286 # auto-generated by ant
 
 JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
               -I"$(JAVA_HOME)/include/$(OS)"
 
-LIBDIR=$(JAVA_HOME)/jre/lib/$(ARCH)
 BUILD=../build/native
 JAVAH=$(BUILD)
 INSTALLDIR=../build/$(OS)
 JNIDISPATCH_OBJS=$(BUILD)/dispatch.o $(BUILD)/callback.o $(EXTRAOBJS)
 RSRC=$(BUILD)/rsrc.o
+ifneq ($(DYNAMIC_LIBFFI),true)
 FFI_SRC=$(shell pwd)/libffi
 FFI_BUILD=$(BUILD)/libffi
-FFI_LIB=$(FFI_BUILD)/.libs/libffi_convenience.a
-FFI_CONFIG=--disable-static --with-pic=yes
+FFI_LIB=$(FFI_BUILD)/.libs/libffi$(ARSFX)
+FFI_ENV=CC="$(CC)" CFLAGS="$(CDEBUG)" CPPFLAGS="$(CDEFINES)"
+FFI_CONFIG=--enable-static --disable-shared --with-pic=yes
+endif
 LIBRARY=$(BUILD)/$(LIBPFX)jnidispatch$(JNISFX)
 TESTLIB=$(BUILD)/$(LIBPFX)testlib$(LIBSFX)
+TESTLIB2=$(BUILD)/$(LIBPFX)testlib2$(LIBSFX)
 
 # Reasonable defaults based on GCC
 LIBPFX=lib
 LIBSFX=.so
+ARSFX=.a
 JNISFX=$(LIBSFX)
 CC=gcc
 LD=gcc
+LIBS=
 # Default to Sun recommendations for JNI compilation
 #COPT=-O2 -fomit-frame-pointer
 COPT=-fno-omit-frame-pointer -fno-strict-aliasing 
@@ -58,14 +64,21 @@
 ifeq ($(DEBUG),true)
 CDEBUG=-g
 endif
+CFLAGS_EXTRA=
 COUT=-o $@
 CINCLUDES=$(JAVA_INCLUDES) -I"$(JAVAH)" -I$(FFI_BUILD)/include
 CDEFINES=-D_REENTRANT
 PCFLAGS=-W -Wall -Wno-unused -Wno-parentheses
-CFLAGS=$(PCFLAGS) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
+CFLAGS=$(PCFLAGS) $(CFLAGS_EXTRA) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
        -DVERSION='"$(VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
+LDFLAGS=-o $@ -shared 
+ifeq ($(DYNAMIC_LIBFFI),true)
+CFLAGS += $(shell pkg-config --cflags libffi 2>/dev/null || echo)
+LIBS += $(shell pkg-config --libs libffi 2>/dev/null || echo -lffi)
+else
 # -static-libgcc avoids gcc library incompatibilities across linux systems
-LDFLAGS=-o $@ -shared -static-libgcc
+LDFLAGS += -static-libgcc
+endif
 # Avoid bug in X11-based 1.5/1.6 VMs; dynamically load instead of linking
 # See http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6539705
 #LIBS=-L"$(LIBDIR)" -ljawt 
@@ -73,47 +86,59 @@
 # end defaults
 
 ifeq ($(OS),win32)
-# Uncomment this line to use MSVC (doesn't yet work with libffi)
-#CC=cl
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
 CDEFINES=-DHAVE_PROTECTION
-
-ifeq ($(CC),cl)
-LD=link
-COPT=-O1 -Op
-ifeq ($(DEBUG),true)
-COPT=-Od
-DBG=d
-CDEBUG=-D_DEBUG -GZ -Zi
-endif
-COUT=-Fo$@
-PCFLAGS=-nologo -MD$(DBG) -W3 -WX -GX -YX -Fd$(@D)/$* -Fp$(@D)/$*
-CASM=-FAs
-
-LDFLAGS=/pdb:$(subst .dll,,$@).pdb /implib:$(subst .dll,,$@).lib /debug /machine:i386 /pdbtype:sept /dll /nologo /opt:REF /incremental:no /out:$@ 
-LIBDIR=/libpath:"$(JAVA_HOME)/lib" 
-#LIBS=$(LIBDIR) jawt.lib
+WINDRES=windres
+EXTRAOBJS=$(RSRC)
 STRIP=@echo
-else
+LIBPFX=
+LIBSFX=.dll
+
+ifeq ($(CC),gcc)
 CC += -mno-cygwin
 LD += -mno-cygwin -Wl,--add-stdcall-alias
-LIBDIR="$(JAVA_HOME)/lib"
-#LIBS=$(LIBDIR)/jawt.lib
-endif
-
-LIBPFX=
-LIBSFX=.dll
-EXTRAOBJS=$(RSRC)
+endif
+
+ifeq ($(ARCH),amd64)
+
+WINDRES=/usr/local/mingw64-cross/bin/x86_64-pc-mingw32-windres
+
+# Uncomment to enable MINGW64 cross compiler
+# Last build attempt has too many runtime problems (alloca broken) (080831)
+#MINGW = x86_64-pc-mingw32-gcc
+ifneq ($(MINGW),)
+CC = $(MINGW) -m64 -mno-cygwin
+LD = $(CC)
+LDFLAGS=-o $@ -shared
+LIBS= -lmingwex -lkernel32 -lmsvcrt
+FFI_CONFIG += --host=x86_64-pc-mingw32
+else
+# MSVC (wrapper scripts)
+CC=$(FFI_SRC)/../cc.sh -m64
+LD=$(FFI_SRC)/../ld.sh -m64
+ARSFX=.lib
+FFI_CONFIG += --host=x86_64-pc-mingw32 && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_SRC)/src/x86/ffitarget.h include
+FFI_ENV += LD="$(LD)" CPP=cpp
+endif
+endif
 endif
 
 ifeq ($(OS),linux)
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
 PCFLAGS+=-fPIC
 CDEFINES+=-DHAVE_PROTECTION
-LDFLAGS+=-Wl,-soname,$@ 
+LDFLAGS+=-Wl,-soname,$@
 endif
 
 ifeq ($(OS),freebsd)
+ARCH=$(shell uname -m | sed 's/i.86/i386/g')
+PCFLAGS+=-fPIC
+CINCLUDES+=-I/usr/X11R6/include
+LDFLAGS=-o $@ -shared 
+CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT
+endif
+
+ifeq ($(OS),openbsd)
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
 PCFLAGS+=-fPIC
 CINCLUDES+=-I/usr/X11R6/include
@@ -137,9 +162,11 @@
 endif
 
 # Enable 64-bit builds if the arch demands it
+ifeq ($(CC),gcc)
 ifeq ($(ARCH),amd64)
   CC += -m64
   LD += -m64
+endif
 endif
 
 ifeq ($(OS),darwin)
@@ -156,8 +183,8 @@
 ISYSROOT=-isysroot $(SDKROOT)
 ARCHFLAGS=-arch ppc -arch i386
 ifneq ($(findstring 10.5,$(SDKROOT)),)
-ALT_ARCHS+=x86_64 #ppc64
-ARCHFLAGS+=-arch x86_64 #-arch ppc64
+ALT_ARCHS+=x86_64 
+ARCHFLAGS+=-arch x86_64
 endif
 endif
 PCFLAGS+=$(ISYSROOT) -x objective-c
@@ -187,27 +214,37 @@
 	$(CC) $(CFLAGS) -c $< $(COUT)
 endif
 
-all: $(LIBRARY) $(TESTLIB)
+all: $(LIBRARY) $(TESTLIB) $(TESTLIB2)
 
 install:
 	mkdir $(INSTALLDIR)
 	cp $(LIBRARY) $(INSTALLDIR)
 
 $(RSRC): $(BUILD)/jnidispatch.rc
-	windres -i $< -o $@
+	$(WINDRES) -i $< -o $@ \
+          || (echo > $@.c && $(CC) $(CFLAGS) -c $@.c $(COUT))
 
 $(LIBRARY): $(JNIDISPATCH_OBJS) $(FFI_LIB) 
 	$(LD) $(LDFLAGS) $(JNIDISPATCH_OBJS) $(FFI_LIB) $(LIBS)
 
 $(TESTLIB): $(BUILD)/testlib.o 
-	$(LD) $(LDFLAGS) $< $(TESTDEF)
-
+	$(LD) $(LDFLAGS) $<
+
+ifeq ($(ARSFX),.lib)
+TESTDEP=$(TESTLIB:.dll=.lib)
+else
+TESTDEP=$(TESTLIB)
+endif
+$(TESTLIB2): $(BUILD)/testlib2.o 
+	$(LD) $(LDFLAGS) $< $(TESTDEP)
+
+ifneq ($(DYNAMIC_LIBFFI),true)
 $(FFI_LIB):
 	@mkdir -p $(FFI_BUILD)
 	@if [ ! -f $(FFI_BUILD)/Makefile ]; then \
 	  echo "Configuring libffi ($(ARCH))"; \
 	  (cd $(FFI_BUILD) \
-	    && CC="$(CC)" CFLAGS="$(CDEBUG)" CPPFLAGS="$(CDEFINES)" $(FFI_SRC)/configure $(FFI_CONFIG)); \
+	    && $(FFI_ENV) $(FFI_SRC)/configure $(FFI_CONFIG)); \
 	fi
 	$(MAKE) -C $(FFI_BUILD)
 ifneq ($(SDKROOT),)
@@ -225,6 +262,7 @@
 	/usr/bin/libtool -static -o $@.tmp $(FFI_BUILD)/.libs/${@F} $(BUILD)/libffi.*/.libs/${@F}
 	mv $@.tmp $@
 endif
+endif
 
 clean:
 	$(RM) -rf $(BUILD)

## libjna-java 3.2.4

=== debian/changelog ===
libjna-java (3.2.4-2ubuntu2) natty; urgency=low

  * Fix incorrect generation of PowerPC multi-arch paths (LP: #737603).

 -- James Page <james.page@canonical.com>  Mon, 28 Mar 2011 09:27:48 +0100

libjna-java (3.2.4-2ubuntu1) natty; urgency=low

  * Fix native library search to be multi-arch compatible (LP: #737603):
    - debian/patches/07-multiarch-support.patch : figure out 
      platform and form search path accordingly. 

 -- James Page <james.page@canonical.com>  Tue, 22 Mar 2011 08:57:17 +0000

libjna-java (3.2.4-2) unstable; urgency=low

  * make libjna-java buildable on GNU/kFreeBSD
  * debian/control: set Build-Depends to default-jdk | openjdk-6-jdk
  * set JAVA_HOME to /usr/lib/jvm/default-java
  * add debian/patches/05-support-gnu-kfreebsd.patch to support
    GNU/kFreeBSD architectures
  * debian/rules: add -Djni.md5="" to ant call
  * import debian/patches/50-remove-gjdoc-inexistent-options.dpatch as
    debian/patches/06-remove-gjdoc-inexistent-options.patch

 -- Jan Dittberner <jandd@debian.org>  Wed, 26 May 2010 00:14:07 +0200

libjna-java (3.2.4-1) unstable; urgency=low

  [ Ludovic Claude ]
  * Team upload.
  * New upstream release
  * Added myself as uploader
  * Add Maven metadata
  * debian/control:
     - add dependency on maven-repo-helper

  [ Jan Dittberner ]
  * refresh patches

 -- Jan Dittberner <jandd@debian.org>  Wed, 21 Apr 2010 16:36:37 +0200

libjna-java (3.2.3-2) unstable; urgency=low

  * Team upload.
  * refresh patches
  * add debian/patches/04-load-native-code-from-fs.patch to try to load
    native library from /usr/lib/jni if system property
    jna.boot.library.path is not set (Closes: #576879)
  * debian/control:
    - set debhelper dependency to >= 7.0.50~
    - update Standards-Version to 3.8.4 (no changes needed)
    - add Vcs-Git and Vcs-Browser fields
  * switch to source format 3.0 (quilt)
    - add debian/source/format
    - remove quilt dependency from debian/control
    - remove patch rules from debian/rules
    - modify clean target to work with unpatched sources too
  * parse version from changelog in debian/rules
  * add myself to Uploaders
  * switch to dh7 rules in debian/rules

 -- Jan Dittberner <jandd@debian.org>  Thu, 08 Apr 2010 14:51:06 +0200

libjna-java (3.2.3-1) unstable; urgency=low

  * New upstream release.
  * Fixed debian/repack-source.sh to correctly use mktemp.
  * Make libjna-java Depends on *-headless packages.
  * Moved package under pkg-java control.
  * Added debian/README.source to describe quilt.
  * Added myself as Uploader.

 -- Michael Koch <konqueror@gmx.de>  Mon, 02 Nov 2009 14:14:51 +0100

libjna-java (3.1.0-5) unstable; urgency=low

  * Removing vcs fields.
  * Removing README.source.
  * Orphaning package.

 -- Daniel Baumann <daniel@debian.org>  Thu, 27 Aug 2009 08:47:56 +0200

libjna-java (3.1.0-4) unstable; urgency=low

  * Rediffing nbproject.patch (Closes: #538624).
  * Updating to standards version 3.8.3.
  * Adding maintainer homepage field to control.
  * Marking maintainer homepage field to be also included in binary
    packages and changelog.
  * Adding README.source.

 -- Daniel Baumann <daniel@debian.org>  Tue, 25 Aug 2009 11:41:51 +0200

libjna-java (3.1.0-3) unstable; urgency=low

  * Updating maintainer field.
  * Updating vcs fields.
  * Updating, sorting and wrapping depends.

 -- Daniel Baumann <daniel@debian.org>  Sat, 15 Aug 2009 09:40:19 +0200

libjna-java (3.1.0-2) unstable; urgency=low

  * Removing watch file.
  * Flipping maintainer and uploaders field.
  * Upgrading package to standards version 3.8.2.
  * Updating package sections.

 -- Daniel Baumann <daniel@debian.org>  Sun, 26 Jul 2009 15:57:25 +0200

libjna-java (3.1.0-1) unstable; urgency=low

  * Updating standards to 3.8.1.
  * Using correct rfc-2822 date formats in changelog.
  * Merging upstream version 3.1.0.
  * Updating version number in rules.
  * Updating year in copyright file.
  * Updating rules file to current state of the art.

 -- Daniel Baumann <daniel@debian.org>  Tue, 09 Jun 2009 11:36:24 +0200

libjna-java (3.0.9-1) unstable; urgency=low

  * Initial release (Closes: #480074).

 -- Daniel Baumann <daniel@debian.org>  Fri, 02 Jan 2009 09:41:00 -0500

=== debian/control ===
Source: libjna-java
Section: java
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Michael Koch <konqueror@gmx.de>, Jan Dittberner <jandd@debian.org>, Ludovic Claude <ludovic.claude@laposte.net>
Build-Depends: debhelper (>= 7.0.50~), default-jdk | openjdk-6-jdk, ant,
 ant-optional, libx11-dev, libxt-dev, libffi-dev, pkg-config, maven-repo-helper
Standards-Version: 3.8.4
Homepage: http://jna.dev.java.net/
Vcs-Git: git://git.debian.org/pkg-java/libjna-java.git
Vcs-Browser: http://git.debian.org/?p=pkg-java/libjna-java.git;a=summary

Package: libjna-java
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, default-jre-headless | java2-runtime-headless
Suggests: libjna-java-doc
Description: Dynamic access of native libraries from Java without JNI
 JNA provides Java programs easy access to native shared libraries without
 writing anything but Java code - no JNI or native code is required. This
 functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
 Access is dynamic at runtime without code generation.
 .
 JNA's design aims to provide native access in a natural way with a minimum of
 effort. No boilerplate or generated code is required. While some attention is
 paid to performance, correctness and ease of use take priority.
 .
 The JNA library uses a small native library stub to dynamically invoke native
 code. The developer uses a Java interface to describe functions and structures
 in the target native library. This makes it quite easy to take advantage of
 native platform features without incurring the high overhead of configuring and
 building JNI code for multiple platforms.

Package: libjna-java-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Dynamic access of native libraries from Java without JNI (documentation)
 JNA provides Java programs easy access to native shared libraries without
 writing anything but Java code - no JNI or native code is required. This
 functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
 Access is dynamic at runtime without code generation.
 .
 This package contains the Javadoc API documentation.

=== debian/rules ===
#!/usr/bin/make -f

export JAVA_HOME=/usr/lib/jvm/default-java

VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

override_dh_auto_clean:
	if [ -f nbproject/profiler-build-impl.xml ]; then \
		ant -f build.xml clean; \
	fi
	rm -f build.number

	dh_clean

override_dh_auto_build:
	ant -f build.xml -Dcflags_extra.native="" -Ddynlink.native=true -Dnomixedjar.native=true -Djni.md5="" jar
	ant -f build.xml javadoc

override_dh_auto_install:
	mh_installpoms -plibjna-java
	mh_installjar -plibjna-java -l --usj-name=jna pom.xml build/jna.jar

override_dh_makeshlibs:
	# don't call dh_makeshlibs

binary: binary-arch binary-indep

%:
	dh $@

=== debian/watch ===
version=3

https://jna.dev.java.net/source/browse/jna/tags/ ([\d\.]+\d)/ debian debian/repack-source.sh

## libjna-java 3.2.7

=== native/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Makefile for JNA native bits
-# Copyright (c) 2007 Timothy Wall All Rights Reserved
+# Copyright (c) 2007-2010 Timothy Wall All Rights Reserved
 #
 # You may need to run 'ant javah' at the root before performing a build from 
 # this directory.
@@ -27,8 +27,8 @@
                         -e 's/Darwin.*/darwin/g' \
                         -e 's/Linux.*/linux/g')
 
-VERSION=3.1.0 # auto-generated by ant
-CHECKSUM=816e53324203bcffe46f43e482e5c286 # auto-generated by ant
+JNA_JNI_VERSION=3.2.2 # auto-generated by ant
+CHECKSUM=c870290c36c8d3fdf85db7c782febc3f # auto-generated by ant
 
 JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
               -I"$(JAVA_HOME)/include/$(OS)"
@@ -42,7 +42,7 @@
 FFI_SRC=$(shell pwd)/libffi
 FFI_BUILD=$(BUILD)/libffi
 FFI_LIB=$(FFI_BUILD)/.libs/libffi$(ARSFX)
-FFI_ENV=CC="$(CC)" CFLAGS="$(CDEBUG)" CPPFLAGS="$(CDEFINES)"
+FFI_ENV=CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)"
 FFI_CONFIG=--enable-static --disable-shared --with-pic=yes
 endif
 LIBRARY=$(BUILD)/$(LIBPFX)jnidispatch$(JNISFX)
@@ -58,8 +58,7 @@
 LD=gcc
 LIBS=
 # Default to Sun recommendations for JNI compilation
-#COPT=-O2 -fomit-frame-pointer
-COPT=-fno-omit-frame-pointer -fno-strict-aliasing 
+COPT=-O2 -fno-omit-frame-pointer -fno-strict-aliasing 
 CASM=-S
 ifeq ($(DEBUG),true)
 CDEBUG=-g
@@ -70,7 +69,7 @@
 CDEFINES=-D_REENTRANT
 PCFLAGS=-W -Wall -Wno-unused -Wno-parentheses
 CFLAGS=$(PCFLAGS) $(CFLAGS_EXTRA) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
-       -DVERSION='"$(VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
+       -DJNA_JNI_VERSION='"$(JNA_JNI_VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
 LDFLAGS=-o $@ -shared 
 ifeq ($(DYNAMIC_LIBFFI),true)
 CFLAGS += $(shell pkg-config --cflags libffi 2>/dev/null || echo)
@@ -87,7 +86,8 @@
 
 ifeq ($(OS),win32)
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
-CDEFINES=-DHAVE_PROTECTION
+CDEFINES=-DHAVE_PROTECTION -DPSAPI_VERSION=1
+LIBS=-lpsapi
 WINDRES=windres
 EXTRAOBJS=$(RSRC)
 STRIP=@echo
@@ -104,18 +104,20 @@
 WINDRES=/usr/local/mingw64-cross/bin/x86_64-pc-mingw32-windres
 
 # Uncomment to enable MINGW64 cross compiler
-# Last build attempt has too many runtime problems (alloca broken) (080831)
+# Should build properly as of 090601, but lacks SEH, so MSVC build is preferred
 #MINGW = x86_64-pc-mingw32-gcc
 ifneq ($(MINGW),)
 CC = $(MINGW) -m64 -mno-cygwin
 LD = $(CC)
 LDFLAGS=-o $@ -shared
-LIBS= -lmingwex -lkernel32 -lmsvcrt
+LIBS= -lmingwex -lpsapi -lkernel32 -lmsvcrt 
 FFI_CONFIG += --host=x86_64-pc-mingw32
 else
 # MSVC (wrapper scripts)
 CC=$(FFI_SRC)/../cc.sh -m64
 LD=$(FFI_SRC)/../ld.sh -m64
+COPT=
+LIBS=psapi.lib
 ARSFX=.lib
 FFI_CONFIG += --host=x86_64-pc-mingw32 && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_SRC)/src/x86/ffitarget.h include
 FFI_ENV += LD="$(LD)" CPP=cpp
@@ -190,8 +192,8 @@
 PCFLAGS+=$(ISYSROOT) -x objective-c
 CDEFINES+=-DTARGET_RT_MAC_CFM=0 -DFFI_MMAP_EXEC_WRIT
 LDFLAGS=$(ARCHFLAGS) -dynamiclib -o $@ -framework JavaVM \
-  -compatibility_version $(shell echo ${VERSION}|sed 's/^\([0-9][0-9]*\).*/\1/g') \
-  -current_version $(VERSION) \
+  -compatibility_version $(shell echo ${JNA_JNI_VERSION}|sed 's/^\([0-9][0-9]*\).*/\1/g') \
+  -current_version $(JNA_JNI_VERSION) \
   -mmacosx-version-min=10.3 \
   -install_name ${@F} \
   $(SYSLIBROOT)
@@ -268,6 +270,6 @@
 	$(RM) -rf $(BUILD) 
 
 version:
-	@echo version=$(VERSION)
+	@echo version=$(JNA_JNI_VERSION)
 
 #EOF

=== debian/changelog ===
libjna-java (3.2.7-4) unstable; urgency=low

  * Remove optional build time dependency on openjdk-6-jdk (depend on
    default-jdk) to fix Debcheck warning.
  * Install jna-platform.jar with javahelper instead of mavenhelper
    (Closes: #629081).

 -- Andrew Ross <ubuntu@rossfamily.co.uk>  Fri, 03 Jun 2011 18:13:57 +0100

libjna-java (3.2.7-3) experimental; urgency=low

  * Seach multiarch paths for libraries (Closes: #620122)

 -- Andrew Ross <ubuntu@rossfamily.co.uk>  Wed, 25 May 2011 21:19:02 +0100

libjna-java (3.2.7-2) unstable; urgency=low

  * Build and install platform.jar too.
  * Bump Standards-Version to 3.9.2.
  * Drop dependency on jre.
  * Update debian/copyright to cover platform code.
  * Add myself to uploaders.

 -- Andrew Ross <ubuntu@rossfamily.co.uk>  Sun, 22 May 2011 21:19:01 +0100

libjna-java (3.2.7-1) unstable; urgency=low

  * New upstream release (Closes: #602564)
  * refresh patches
  * switch debian/watch to new kenai URL
  * change SVN URL in debian/repack-source.sh
  * fix debian/repack-source.sh to use the directory given to uscan via
    -destdir
  * add mh_clean to clean target in debian/rules
  * bump Standards-Version to 3.9.1
  * bump maven-repo-helper dependency to (>= 1.5~)
  * don't compress example java files

 -- Jan Dittberner <jandd@debian.org>  Sun, 20 Feb 2011 15:18:39 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: libjna-java
 Section: java
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
-Uploaders: Michael Koch <konqueror@gmx.de>, Jan Dittberner <jandd@debian.org>, Ludovic Claude <ludovic.claude@laposte.net>
-Build-Depends: debhelper (>= 7.0.50~), default-jdk | openjdk-6-jdk, ant,
- ant-optional, libx11-dev, libxt-dev, libffi-dev, pkg-config, maven-repo-helper
-Standards-Version: 3.8.4
+Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
+Uploaders: Michael Koch <konqueror@gmx.de>, Jan Dittberner <jandd@debian.org>, 
+ Ludovic Claude <ludovic.claude@laposte.net>, Andrew Ross <ubuntu@rossfamily.co.uk>
+Build-Depends: debhelper (>= 7.0.50~), default-jdk, ant,
+ ant-optional, libx11-dev, libxt-dev, libffi-dev, pkg-config,
+ maven-repo-helper (>= 1.5~), javahelper (>=0.32~)
+Standards-Version: 3.9.2
 Homepage: http://jna.dev.java.net/
 Vcs-Git: git://git.debian.org/pkg-java/libjna-java.git
 Vcs-Browser: http://git.debian.org/?p=pkg-java/libjna-java.git;a=summary
 
 Package: libjna-java
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, default-jre-headless | java2-runtime-headless
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: libjna-java-doc
 Description: Dynamic access of native libraries from Java without JNI
  JNA provides Java programs easy access to native shared libraries without

=== debian/rules ===
--- 
+++ 
@@ -9,21 +9,27 @@
 		ant -f build.xml clean; \
 	fi
 	rm -f build.number
-
+	rm -rf build doc
+	rm -rf contrib/platform/build
+	mh_clean
 	dh_clean
 
 override_dh_auto_build:
-	ant -f build.xml -Dcflags_extra.native="" -Ddynlink.native=true -Dnomixedjar.native=true -Djni.md5="" jar
+	ant -f build.xml -Dcflags_extra.native="" -Ddynlink.native=true -Dnomixedjar.native=true -Djni.md5="" jar contrib-jars
 	ant -f build.xml javadoc
 
+# install. using platform.jar is a silly idea in /usr/share/java/ as it's bound to collide
 override_dh_auto_install:
-	mh_installpoms -plibjna-java
 	mh_installjar -plibjna-java -l --usj-name=jna pom.xml build/jna.jar
+	jh_installlibs -plibjna-java build/jna-platform.jar
 
 override_dh_makeshlibs:
 	# don't call dh_makeshlibs
 
+override_dh_compress:
+	dh_compress -X.java
+
 binary: binary-arch binary-indep
 
 %:
-	dh $@
+	dh $@ --with maven-repo-helper

=== debian/watch ===
version=3

https://svn.java.net/svn/jna~svn/tags/ ([\d\.]+\d)/ debian debian/repack-source.sh

## libjna-java 4.1.0

=== native/Makefile ===
#
# Makefile for JNA native bits
# Copyright (c) 2007-2012 Timothy Wall All Rights Reserved
#
# You may need to run 'ant javah' at the root before performing a build from
# this directory.
#
# To build with debug information, use 'make DEBUG=true'
#
# Supported platforms (built and tested):
#
#   Windows 2000/XP/2003/Vista (x86/amd64)
#   Windows CE/Mobile (arm)
#   Darwin/OS X (i386/x86_64/ppc)
#   Linux (i386/amd64/ppc/arm)
#   Solaris (i386/amd64/sparc/sparcv9)
#   AIX (ppc/ppc64)
#   FreeBSD/OpenBSD/NetBSD (i386/amd64)
#   Android (arm/x86)
#
# Built, but with outstanding bugs (not necessarily within JNA):
#
#   Linux (ppc64/ia64)
#
# The w32ce build requires cegcc and phoneME for cross-compilation; if these
# tools are available on the path then "ant -Dos.prefix=w32ce-arm" should
# result in a proper build.
#
# The android build requires the android SDK+NDK for cross-compilation;
# make the tools available on the path and compile with
# "ant -Dos.prefix=android-arm(-x86)".  Put the NDK tools in the path and adjust
# NDK_PLATFORM below or set it in your environment.
#

# Systems which support POSIX signals may be able to support VM crash
# protection simply by defining HAVE_PROTECTION.  This option has been only
# been enabled for those platforms on which it has been tested successfully.

OS=$(shell uname | sed -e 's/CYGWIN.*/win32/g' \
	                -e 's/MINGW32.*/win32/g' \
                        -e 's/SunOS.*/solaris/g' \
                        -e 's/NetBSD/netbsd/g' \
                        -e 's/GNU\/kFreeBSD/kfreebsd/g' \
                        -e 's/FreeBSD/freebsd/g' \
                        -e 's/OpenBSD/openbsd/g' \
                        -e 's/Darwin.*/darwin/g' \
                        -e 's/AIX.*/aix/g' \
                        -e 's/Linux.*/linux/g')

JNA_JNI_VERSION=4.0.0 # auto-generated by ant
CHECKSUM=1a6047467b59e8748f975e03016ce3d9 # auto-generated by ant

JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
              -I"$(JAVA_HOME)/include/$(OS)"

BUILD=../build/native
JAVAH=$(BUILD)
INSTALLDIR=../build/$(OS)
JNIDISPATCH_OBJS=$(BUILD)/dispatch.o $(BUILD)/callback.o $(EXTRAOBJS)
RSRC=$(BUILD)/rsrc.o
DLLCB=$(BUILD)/dll-callback.o
ifneq ($(DYNAMIC_LIBFFI),true)
FFI_SRC=$(shell pwd)/libffi
FFI_BUILD=$(BUILD)/libffi
FFI_LIB=$(FFI_BUILD)/.libs/libffi$(ARSFX)
FFI_ENV=CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)"
FFI_CONFIG=--enable-static --disable-shared --with-pic=yes
endif
LIBRARY=$(BUILD)/$(LIBPFX)jnidispatch$(JNISFX)
TESTLIB=$(BUILD)/$(LIBPFX)testlib$(LIBSFX)
TESTLIB_JAR=$(BUILD)/$(LIBPFX)testlib-jar$(LIBSFX)
TESTLIB_PATH=$(BUILD)/$(LIBPFX)testlib-path$(LIBSFX)
TESTLIB_TRUNC=$(BUILD)/testlib-truncated
TESTLIB2=$(BUILD)/$(LIBPFX)testlib2$(LIBSFX)

# Reasonable defaults based on GCC
LIBPFX=lib
LIBSFX=.so
ARSFX=.a
JNISFX=$(LIBSFX)
CC=gcc
LD=$(CC)
LIBS=
# Default to Sun recommendations for JNI compilation
COPT=-O2 -fno-omit-frame-pointer -fno-strict-aliasing
CASM=-S
ifeq ($(DEBUG),true)
CDEBUG=-g
endif
CFLAGS_EXTRA=
COUT=-o $@
CINCLUDES=$(JAVA_INCLUDES) -I"$(JAVAH)" -I$(FFI_BUILD)/include
CDEFINES=-D_REENTRANT
PCFLAGS=-W -Wall -Wno-unused -Wno-parentheses
CFLAGS=$(PCFLAGS) $(CFLAGS_EXTRA) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
       -DJNA_JNI_VERSION='"$(JNA_JNI_VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
LDFLAGS=-o $@ -shared
ifeq ($(DYNAMIC_LIBFFI),true)
CFLAGS += $(shell pkg-config --cflags libffi 2>/dev/null || echo)
LIBS += $(shell pkg-config --libs libffi 2>/dev/null || echo -lffi)
else
# -static-libgcc avoids gcc library incompatibilities across linux systems
LDFLAGS += -static-libgcc
endif
# Avoid bug in X11-based 1.5/1.6 VMs; dynamically load instead of linking
# See http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6539705
#LIBS=-L"$(LIBDIR)" -ljawt
STRIP=strip -x
# end defaults

# Android build (cross-compile) requires the android SDK+NDK.
# Ensure the following tools are in your path and adjust NDK_PLATFORM as needed
ifeq ($(OS),android)
ifeq ($(ARCH),arm)
PREFIX=arm-linux-androideabi-
COPT+= -mthumb-interwork -march=armv5te -mtune=xscale -msoft-float -fstack-protector 
HOST=arm-linux-eabi
else
PREFIX=i686-android-linux-
COPT+= -march=i686
HOST=i686-linux
endif
CC=$(PREFIX)gcc
CPP=$(PREFIX)cpp
LD=$(PREFIX)gcc
RANLIB=$(PREFIX)ranlib
STRIP=$(PREFIX)strip -x
CDEFINES=-DNO_JAWT -DNO_WEAK_GLOBALS -DFFI_MMAP_EXEC_WRIT=1 -DFFI_MMAP_EXEC_SELINUX=0
COPT+=-fpic -ffunction-sections -funwind-tables -fno-short-enums
NDK_PLATFORM?=/Developer/Applications/android-ndk-r7c/platforms/android-14
JAVA_INCLUDES=
CINCLUDES+=-I"$(NDK_PLATFORM)/arch-$(ARCH)/usr/include" # -I/usr/include
LIBS=-nostdlib -L"$(NDK_PLATFORM)/arch-$(ARCH)/usr/lib/" -lgcc -lc -ldl -lm
LDFLAGS+=-Wl,-shared,-Bsymbolic
FFI_ENV=CPP="$(CPP)" CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG) $(CINCLUDES)" CPPFLAGS="$(CDEFINES) $(CINCLUDES)" LIBS="$(LIBS)" RANLIB="$(RANLIB)"
FFI_CONFIG=--enable-static --disable-shared --with-pic=yes --host=$(HOST)
endif

# W32CE build requires cegcc cross-compiler and phoneME JavaME implementation
# cegcc: http://sf.net/projects/cegcc
# phoneme: http://davy.preuveneers.net/
ifeq ($(OS),w32ce)
ARCH=arm
CC=arm-mingw32ce-gcc -mwin32
CDEFINES=-D_WIN32_IE=0x400 -D_WIN32_WCE=0x0420 -DNO_JAWT -DNO_NIO_BUFFERS -DWINCE -D_WIN32_STDARG_H
CFLAGS+=-Wno-unknown-pragmas
LD=arm-mingw32ce-gcc
LDFLAGS=-o $@ -shared
LIBS=-lcoredll -lgcc -ltoolhelp
WINDRES=arm-mingw32ce-windres
EXTRAOBJS=$(RSRC)
STRIP=arm-mingw32ce-strip -x
LIBPFX=
LIBSFX=.dll
HOST_CONFIG=--host=arm-mingw32ce
# libffi must use GNU ld; jnidispatch.dll requires gcc
FFI_ENV+=LD=arm-mingw32ce-ld CPP=cpp CFLAGS="$(CDEFINES)"
PHONEME=../phoneme/cdc/src
JAVA_INCLUDES=-I$(PHONEME)/share/javavm/export -I$(PHONEME)/share -I$(PHONEME)/win32 -I$(PHONEME)/win32-arm
TESTLIB_TRUNC=$(BUILD)/testlib-truncated.dll
endif

ifeq ($(OS),win32)
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
ifdef $(MSVC)
USE_MSVC=true
endif

CDEFINES=-DHAVE_PROTECTION -DPSAPI_VERSION=1 -DFFI_BUILDING -DUNICODE -D_UNICODE
ifndef USE_MSVC
LIBS=-lpsapi
else
ARSFX=.lib
COPT=
LIBS=psapi.lib
endif
WINDRES=windres
EXTRAOBJS=$(RSRC)
STRIP=@echo
LIBPFX=
LIBSFX=.dll
TESTLIB_TRUNC=$(BUILD)/testlib-truncated.dll

ifneq ($(ARCH),amd64)
ifdef USE_MSVC
CC=$(FFI_SRC)/../cc.sh -m32
CPP=$(FFI_SRC)/../cc.sh -m32 -E
LD=$(FFI_SRC)/../ld.sh -m32
FFI_CONFIG+= && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_SRC)/src/x86/ffitarget.h include
FFI_ENV+=LD="$(LD)" CPP="$(CPP)" 
endif

ifeq ($(CC),gcc)
# -mno-cygwin is only available on GCC 3; GCC 4 requires an explicit mingw
# installation
GCC_VERSION = $(shell gcc --version | sed -n 's/.*(GCC) \([0-9]\)\.[0-9.]*.*/\1/p')
ifeq ($(GCC_VERSION),3)
NOCYGWIN=-mno-cygwin
else
NOCYGWIN=
endif
CC += $(NOCYGWIN)
LD += $(NOCYGWIN) -Wl,--add-stdcall-alias
endif

else 

# Undefine USE_MSVC to enable mingw64 cross compiler; ensure $(MINGW) is in
# PATH.  Should build properly as of 111121, but lacks SEH, so MSVC build is
# preferred
MINGW_PREFIX?=x86_64-w64-mingw32-
MINGW=$(MINGW_PREFIX)gcc 
# Still need windres from mingw distribution, even if building with MSVC
WINDRES=$(MINGW_PREFIX)windres
ifndef USE_MSVC
CC=$(MINGW)
endif

ifeq ($(CC),$(MINGW))
# No SEH under mingw64, thus no HAVE_PROTECTION
CDEFINES=-DPSAPI_VERSION=1
LD = $(CC)
LDFLAGS=-o $@ -shared
LIBS= -lmingwex -lpsapi -lkernel32 -lmsvcrt
FFI_CONFIG += --host=x86_64-w64-mingw32
else
# MSVC (wrapper scripts)
CC=$(FFI_SRC)/../cc.sh -m64
CPP=$(FFI_SRC)/../cc.sh -m64 -E
LD=$(FFI_SRC)/../ld.sh -m64
FFI_CONFIG+=--host=x86_64-w64-mingw32 && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_SRC)/src/x86/ffitarget.h include
FFI_ENV+=LD="$(LD)" CPP="$(CPP)" 
EXTRAOBJS+=$(DLLCB)
endif
endif
endif

ifeq ($(OS),linux)
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
PCFLAGS+=-fPIC
CDEFINES+=-DHAVE_PROTECTION
LDFLAGS+=-Wl,-soname,$@
endif

ifneq (,$(findstring bsd,$(OS)))
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
PCFLAGS+=-fPIC
CINCLUDES+=-I/usr/X11R6/include
LDFLAGS=-o $@ -shared
CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT -DUSE_DEAFULT_LIBNAME_ENCODING
endif

ifeq ($(OS),solaris)
ifeq ($(ARCH),)
ARCH=$(shell uname -p)
endif
PCFLAGS+=-fPIC
CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT -DUSE_DEFAULT_LIBNAME_ENCODING
ifeq ($(ARCH), sparcv9)
  # alter CC instead of PCFLAGS, since we need to pass it down to libffi
  # configure and some of the other settings in PCFLAGS might make the build
  # choke
  CC += -m64
  LD += -m64
endif
endif


ifeq ($(OS),aix)
LIBSFX=.a
PCFLAGS+=-fPIC
CDEFINES+=-DHAVE_PROTECTION -DNO_JAWT -Wall -D_AIX -DPOWERPC_AIX -D_THREAD_SAFE_ERRNO
COPT+=-D_AIX -DPOWERPC_AIX -mxl-compat
LDFLAGS+=-Wl,-lc128,-lc,-lm,-lpthread
FFI_ENV+=AR_FLAGS="-X32_64 cru"
STRIP=echo strip -X32_64

ifeq ($(ARCH),ppc64)
  COPT+=-maix64
  LDFLAGS+=$(COPT)
  HOST_CONFIG=--host=ppc-aix64
endif
ifeq ($(ARCH),ppc)
  COPT+=-maix32
  LDFLAGS+=$(COPT)
  HOST_CONFIG=--host=ppc-aix
endif
endif


# Enable 64-bit builds if the arch demands it
ifeq ($(CC),gcc)
ifneq ($(OS),aix)
ifeq ($(ARCH),amd64)
  CC += -m64
  LD += -m64
endif
ifeq ($(ARCH),ppc64)
  CC += -m64
  LD += -m64
endif
ifeq ($(ARCH),ppc)
  CC += -m32
  LD += -m32
  HOST_CONFIG=--host=ppc-linux
endif
ifeq ($(ARCH),i386)
  CC += -m32
  LD += -m32
endif
endif
endif


ifeq ($(OS),darwin)
XCODE_VERSION=$(shell xcodebuild -version | grep Xcode | sed 's/^Xcode \([1-9]\).*/\1/g')
JAVA_INCLUDES=-I/System/Library/Frameworks/JavaVM.framework/Headers
DEFAULT_ARCH=$(shell arch)
ARCH=$(shell arch)
HOST_CONFIG=--host $(ARCH)-apple-darwin
FFI_ENV += CC="$(CC)" CFLAGS="-arch $(ARCH) $(ISYSROOT) $(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)" LD="$(LD) -arch $(ARCH)"
ALT_ARCHS=
ifneq ($(ARCH),i386)
ALT_ARCHS+=i386
endif
ifneq ($(ARCH),x86_64)
ALT_ARCHS+=x86_64
endif
ifneq ($(ARCH),ppc)
ifeq ($(XCODE_VERSION),3)
# Xcode 3 options
# not supported on XCode 4+
ALT_ARCHS+=ppc
else
# Xcode 4+ options
NO_COMPACT_UNWIND=-Wl,-no_compact_unwind
endif
endif
LIBSFX=.dylib
JNISFX=.jnilib
ifneq ($(SDKROOT),)
SYSLIBROOT=-Wl,-syslibroot,$(SDKROOT)
ISYSROOT=-isysroot $(SDKROOT)
ARCHFLAGS=-arch i386 -arch x86_64
ifeq ($(XCODE_VERSION),3)
ARCHFLAGS+=-arch ppc
endif
endif

PCFLAGS+=$(ISYSROOT) -x objective-c
CDEFINES+=-DTARGET_RT_MAC_CFM=0 -DFFI_MMAP_EXEC_WRIT
LDFLAGS=$(ARCHFLAGS) -dynamiclib -o $@ -framework JavaVM \
  -compatibility_version $(shell echo ${JNA_JNI_VERSION}|sed 's/^\([0-9][0-9]*\).*/\1/g') \
  -current_version $(JNA_JNI_VERSION) \
  -mmacosx-version-min=10.3 \
  -framework Foundation \
  $(NO_COMPACT_UNWIND) \
  -install_name ${@F} \
  $(SYSLIBROOT)
# JAWT linkage handled by -framework JavaVM
LIBS=
endif

# Unfortunately, we have to use different libffi include files depending on
# the target, so we can't do a simple universal build on darwin.  Do
# separate builds, then merge the results.
$(BUILD)/%.o : %.c dispatch.h protect.h $(FFI_LIB)
	@mkdir -p $(BUILD)
ifneq ($(SDKROOT),)
	$(CC) -arch $(ARCH) $(CFLAGS) -c $< -o $@.$(ARCH)
	for arch in $(ALT_ARCHS); do \
	  $(CC) -arch $$arch -I$(BUILD)/libffi.$$arch/include $(CFLAGS) -c $< -o $@.$$arch; \
	done
	lipo -create -output $@ $@.*
else
	$(CC) $(CFLAGS) -c $< $(COUT)
endif

all: $(LIBRARY) $(TESTLIB) $(TESTLIB2) $(TESTLIB_JAR) $(TESTLIB_PATH) $(TESTLIB_TRUNC)

install:
	mkdir $(INSTALLDIR)
	cp $(LIBRARY) $(INSTALLDIR)

$(DLLCB): dll-callback.c 
	$(MINGW) -DDEFINE_CALLBACKS -c $< $(COUT)

$(RSRC): $(BUILD)/jnidispatch.rc $(BUILD)/$(JNA_JNI_VERSION).stamp
	$(WINDRES) -i $< -o $@ \
          || (echo > $@.c && $(CC) $(CFLAGS) -c $@.c $(COUT))

$(BUILD)/$(JNA_JNI_VERSION).stamp:
	@touch $@

$(LIBRARY): $(JNIDISPATCH_OBJS) $(FFI_LIB)
	$(LD) $(LDFLAGS) $(JNIDISPATCH_OBJS) $(FFI_LIB) $(LIBS)
	$(STRIP) $@

$(TESTLIB): $(BUILD)/testlib.o
	$(LD) $(LDFLAGS) $< $(LIBS)

# These targets provide for different shared library loading methods
# without getting into native library load conflicts
$(TESTLIB_JAR) $(TESTLIB_PATH) $(TESTLIB_TRUNC): $(TESTLIB)
	@cp $< $@

ifeq ($(ARSFX),.lib)
TESTDEP=$(TESTLIB:.dll=.lib)
else
TESTDEP=$(TESTLIB)
endif
$(TESTLIB2): $(BUILD)/testlib2.o

=== debian/changelog ===
libjna-java (4.1.0-1) unstable; urgency=low

  * Team upload

  [ Andrew Ross ]
  * New upstream release (Closes: #733488)
  * Refreshed the patches (up to version 3.4.1)
  * Link javadoc to default-jdk API
  * Remove Michael Koch <konqueror@gmx.de> from uploaders (Closes: #654084).
  * Use hardening-wrapper to correct lintian warnings.
  * Update d/watch for new upstream location

  [ Emmanuel Bourg ]
  * Refreshed the patches (up to version 4.1.0)
  * Removed 08-multiarch-support.patch (merged upstream since JNA 3.5.0)
  * Removed 02-builddir.patch (merged upstream since 4.0.0)
  * Removed 05-support-gnu-kfreebsd.patch (merged upstream since 4.0.0)
  * Added a default implementation of Structure.getFieldOrder() to preserve
    the compatibility with JNA < 3.5.0
  * Moved libjnidispatch.so into its own new arch any libjna-jni package
  * Install libjnidispatch.so in a multiarch path
  * Install the Maven artifacts for the platform jar (Closes: #743732)
  * Moved platform.jar to its own libjna-platform-java package
  * Added a repack script to clean the upstream tarball
  * Install the upstream changelog
  * debian/control:
    - Use canonical URLs for the Vcs-* fields
    - Standards-Version updated to 3.9.6 (no changes)
  * Switch to debhelper level 9
  * debian/copyright:
    - Updated to the Copyright Format 1.0
    - Fixed the short name of the license applied to the debian/* files
    - JNA is now dual licensed under the LGPL-2.1+ or the Apache-2.0 license

 -- Emmanuel Bourg <ebourg@apache.org>  Thu, 16 Oct 2014 00:23:15 +0200

=== debian/control ===
--- 
+++ 
@@ -2,19 +2,29 @@
 Section: java
 Priority: optional
 Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
-Uploaders: Michael Koch <konqueror@gmx.de>, Jan Dittberner <jandd@debian.org>, 
- Ludovic Claude <ludovic.claude@laposte.net>, Andrew Ross <ubuntu@rossfamily.co.uk>
-Build-Depends: debhelper (>= 7.0.50~), default-jdk, ant,
- ant-optional, libx11-dev, libxt-dev, libffi-dev, pkg-config,
- maven-repo-helper (>= 1.5~), javahelper (>=0.32~)
-Standards-Version: 3.9.2
-Homepage: http://jna.dev.java.net/
-Vcs-Git: git://git.debian.org/pkg-java/libjna-java.git
-Vcs-Browser: http://git.debian.org/?p=pkg-java/libjna-java.git;a=summary
+Uploaders: Jan Dittberner <jandd@debian.org>,
+           Ludovic Claude <ludovic.claude@laposte.net>,
+           Andrew Ross <ubuntu@rossfamily.co.uk>
+Build-Depends: ant,
+               ant-optional,
+               debhelper (>= 9),
+               default-jdk,
+               default-jdk-doc,
+               hardening-wrapper,
+               javahelper (>=0.32~),
+               libffi-dev,
+               libx11-dev,
+               libxt-dev,
+               maven-repo-helper (>= 1.5~),
+               pkg-config
+Standards-Version: 3.9.6
+Vcs-Git: git://anonscm.debian.org/pkg-java/libjna-java.git
+Vcs-Browser: http://anonscm.debian.org/cgit/pkg-java/libjna-java.git
+Homepage: https://github.com/twall/jna
 
 Package: libjna-java
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Architecture: all
+Depends: libjna-jni, ${misc:Depends}
 Suggests: libjna-java-doc
 Description: Dynamic access of native libraries from Java without JNI
  JNA provides Java programs easy access to native shared libraries without
@@ -32,6 +42,31 @@
  native platform features without incurring the high overhead of configuring and
  building JNI code for multiple platforms.
 
+Package: libjna-jni
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: Dynamic access of native libraries from Java without JNI (native libs)
+ JNA provides Java programs easy access to native shared libraries without
+ writing anything but Java code - no JNI or native code is required. This
+ functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
+ Access is dynamic at runtime without code generation.
+ .
+ This package contains the native libraries for libjna-java
+
+Package: libjna-platform-java
+Architecture: all
+Depends: libjna-java, ${misc:Depends}
+Replaces: libjna-java (<< 3.4.2)
+Breaks: libjna-java (<< 3.4.2)
+Description: Dynamic access of native libraries from Java without JNI (platform extension)
+ JNA provides Java programs easy access to native shared libraries without
+ writing anything but Java code - no JNI or native code is required. This
+ functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
+ Access is dynamic at runtime without code generation.
+ .
+ This package contains the platform library with many native functions already
+ mapped as well as a set of utility interfaces that simplify native access.
+
 Package: libjna-java-doc
 Section: doc
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

export JAVA_HOME=/usr/lib/jvm/default-java
export DEB_BUILD_HARDENING=1

DEB_HOST_MULTIARCH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

%:
	dh $@

override_dh_auto_clean:
	ant -f build.xml -Dmaven-release=true clean
	rm -f build.number
	rm -rf build doc
	rm -rf contrib/platform/build
	rm -rf contrib/platform/dist
	rm -f dist/*
	mh_clean
	dh_clean

override_dh_auto_build:
	ant -f build.xml \
	    -Dcflags_extra.native="" \
	    -Ddynlink.native=true \
	    -Dnomixedjar.native=true \
	    -Djni.md5="" \
	    -Djar.compress=true \
	    -Dmaven-release=true \
	    -Dbuild-native=true \
	    jar javadoc contrib-jars native

# install. using platform.jar is a silly idea in /usr/share/java/ as it's bound to collide
override_dh_auto_install:
	mh_installpom -plibjna-java -e$(VERSION) pom-jna.xml
	mh_installjar -plibjna-java -e$(VERSION) --java-lib --usj-name=jna pom-jna.xml build/jna.jar

	mh_installpom -plibjna-platform-java -e$(VERSION) pom-jna-platform.xml
	mh_installjar -plibjna-platform-java -e$(VERSION) --java-lib --usj-name=jna-platform pom-jna-platform.xml contrib/platform/dist/jna-platform.jar

	dh_install -plibjna-jni build/native*/libjnidispatch.so usr/lib/$(DEB_HOST_MULTIARCH)/jni

	dh_installchangelogs CHANGES.md

override_dh_makeshlibs:
	# don't call dh_makeshlibs

override_dh_compress:
	dh_compress -X.java

binary: binary-arch binary-indep

## libjna-java 4.2.0

=== debian/changelog ===
libjna-java (4.2.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Refreshed the patches

 -- Emmanuel Bourg <ebourg@apache.org>  Sat, 03 Oct 2015 00:46:21 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,13 @@
 	dh $@
 
 override_dh_auto_clean:
-	ant -f build.xml -Dmaven-release=true clean
+	#ant -f build.xml -Dmaven-release=true clean
+	find -name build -type d | xargs -r rm -Rf
 	rm -f build.number
 	rm -rf build doc
 	rm -rf contrib/platform/build
 	rm -rf contrib/platform/dist
+	rm -Rf contrib/ntservice/dist
 	rm -f dist/*
 	mh_clean
 	dh_clean

## libjna-java 4.2.1

=== debian/changelog ===
libjna-java (4.2.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Improved the reproducibility:
    - Set the locale and remove the timestamps when generating the javadoc

 -- Emmanuel Bourg <ebourg@apache.org>  Tue, 03 Nov 2015 23:27:46 +0100
